#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <conio.h>

const int BUF_SIZE = 256;
const int BUF_HALF = 128;
const int SBUF_SIZE = 16;
const int RESIZE = BUF_HALF/SBUF_SIZE;
const int FEEDBACKS_MAX = 11;

const int ADPCM_UNIT = 32;

struct adpcm_common{
 double wav_buf[BUF_SIZE];
 double psycho_ac_big[BUF_HALF];
 double psycho_ac[SBUF_SIZE];
 double feedbacks[SBUF_SIZE];
 double errors_bf[SBUF_SIZE];
 double ath_curve_big[BUF_HALF];
 double ath_curve[SBUF_SIZE];
 double mask_spread_for[BUF_HALF];
 double mask_spread_rev[BUF_HALF];
 double mask_spread_norm[BUF_HALF];

 char wav_comp[ADPCM_UNIT];
 int sign_hist[4];
 int evalfs_hist[22];
 int evalfe_hist[22];
 double play_volume;
 //wav_buf ݃GR[h悤ƂĂ錳g`0`ADPCM_UNIT-1ɁA
 //        ꂩ̖̔g``BUF_SIZE-1܂œĂB
 //psycho_ac 0`TvOg2[Hz]܂ł̎gƂ̋emCY
 //          (}XLOl)ĂBjAB傫
 //          mCYƁAɂȂB
 //feedbacks tB[hobNWBfeedbacks[0]͕K1.0B
 //          feedbacks_max-1܂ŒlĂāAȍ~0.0B
 //errors_bf ςݏグG[Bwav_bufɃG[㏑ƁA
 //          ̔g`𒲂ׂȂȂ邽߁Aerror_bfɕۊǂB
 //ath_curve Ήl(ATH)BjAB
 //mask_spread }XLOBBUF_HALF̎gт̒ŁA1ш
 //            փ}XNLxB1barkшւ-10dBxA
 //            1barkႢшւ-25dBx}XNL炵B
 //mask_spread_norm ̂܂܃}XNLƁA͍L₷̂ŁA
 //                 Zƍ悪傫ȂĂ܂̂ŁAWB


 //wav_comp  8bitɈkʂi[B

};

int init_adpcm_common(struct adpcm_common *adpc){
 for(int i=0;i<BUF_SIZE;i++)adpc->wav_buf[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->psycho_ac_big[i] = 1000.0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->psycho_ac[i] = 0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->ath_curve[i] = 0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->feedbacks[i] = 0;
 for(int i=0;i<SBUF_SIZE;i++)adpc->errors_bf[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->ath_curve_big[i] = 0;
 for(int i=0;i<BUF_HALF;i++)adpc->mask_spread_for[i] = 0; //10dB/bark
 for(int i=0;i<BUF_HALF;i++)adpc->mask_spread_rev[i] = 0; //25dB/bark
 for(int i=0;i<BUF_HALF;i++)adpc->mask_spread_norm[i] = 0;
 for(int i=0;i<ADPCM_UNIT;i++)adpc->wav_comp[i] = 0;
 for(int i=0;i<4;i++)adpc->sign_hist[i] = 0;
 adpc->feedbacks[0] = 1.0;
 adpc->play_volume = 0.0;
 return 0;
}

int prepare_psycho_param(struct adpcm_common *adpc,double s_rate){
 // oS̃p[^ZoĊi[܂B1GR[hɂ1ĂׂOKB
 // ISO 226 :2003 standard 20phon
 //   bark             0   1    2    3    4    5    6    7    8    9    10   11   12   13   14   15   16   17   18   19   20   21   22   23    24    25    26    27    28
 //double barkgen[27]={0, 100, 200, 300, 400, 510, 630, 770, 920, 1080,1270,1480,1720,2000,2320,2700,3200,3900,4800,5700,6800,8100,9300,11000,13000,16100,21500,37300,99900};
 double athcgen[29] = {60, 46, 34,  28,  26,  23,  22,  21,  20,   20,  21,  22,  21,  19,  17,  16,  14,  15,  16,  19,  26,  31,  33,  35,   34,   36,   66,   63,   63};
 double hz = 0.3*s_rate/BUF_SIZE;
 double bark;
 double barkgen[BUF_HALF];
 int i,j;
 adpc->play_volume = pow(10.0,37.0/20.0);

 for(i=0;i<BUF_HALF;i++){
  bark = 13.0*atan(hz*0.00076)+4.7*atan((hz/10000.0)*(hz/10000.0));
  barkgen[i] = bark;
  double db = athcgen[(int)bark]+(bark-((int)bark))*(athcgen[1+(int)bark]-athcgen[(int)bark]);
  hz += s_rate/BUF_SIZE;

  adpc->ath_curve_big[i] = pow(10.0,db/20.0);
 }
 for(i=0;i<SBUF_SIZE;i++){
  double db_acum = 0.0;
  for(j=0;j<RESIZE;j++){
   db_acum += 1.0/adpc->ath_curve_big[i*RESIZE+j];
  }
  adpc->ath_curve[i] = db_acum/RESIZE;
 }

 for(i=0;i<BUF_HALF;i++){
  adpc->mask_spread_for[i] = 0.0;
  adpc->mask_spread_rev[i] = 0.0;
  if((i+1)<BUF_HALF)adpc->mask_spread_for[i] = pow(0.1,(barkgen[i+1]-barkgen[i])*0.5);//10dB,25dB
  if(i>0)adpc->mask_spread_rev[i] = pow(0.1,(barkgen[i]-barkgen[i-1])*1.25);
 }

 double mask_thre = 0.0;
 for(i=0;i<BUF_HALF;i++){
  mask_thre += 1.0;
  adpc->mask_spread_norm[i] = mask_thre;
  mask_thre *= adpc->mask_spread_for[i];
 }
 mask_thre = 0.0;
 for(i=BUF_HALF-1;i>=0;i--){
  mask_thre += adpc->mask_spread_norm[i];
  adpc->mask_spread_norm[i] = mask_thre;
  mask_thre *= adpc->mask_spread_rev[i];
 }
 for(i=0;i<BUF_HALF;i++){
  adpc->mask_spread_norm[i] = 100.0*adpc->play_volume/adpc->mask_spread_norm[i];
 }

 return 0;
}

void fft1(double ar[], double ai[], int n, int iter, int flag){
	int i, it, j, j1, j2, k, xp, xp2;
	double arg, dr1, dr2, di1, di2, tr, ti, w, wr, wi;

	if(n < 2)
	{
		fprintf(stderr, "Error : n < 2  in fft1()\n");
		return;
	}
	if(iter <= 0)
	{
		iter = 0;
		i = n;
		while((i /= 2) != 0)	iter++;
	}
	j = 1;
	for(i = 0; i < iter; i++)	j *= 2;
	if(n != j)
	{
		fprintf(stderr, "Error : n != 2 ^ k  in fft1()\n");
		return;
	}
	w = (flag? M_PI: -M_PI) / (double)n;
	xp2 = n;
	for(it = 0; it < iter; it++)
	{
		xp = xp2;
		xp2 /= 2;
		w *= 2;
		for(k = 0, i = - xp; k < xp2; i++)
		{
			wr = cos(arg = w * k++);
			wi = sin(arg);
			for(j = xp; j <= n; j += xp)
			{
				j2 = (j1 = j + i) + xp2;
				tr = (dr1 = ar[j1]) - (dr2 = ar[j2]);
				ti = (di1 = ai[j1]) - (di2 = ai[j2]);
				ar[j1] = dr1 + dr2;
				ai[j1] = di1 + di2;
				ar[j2] = tr * wr - ti * wi;
				ai[j2] = ti * wr + tr * wi;
			}
		}
	}
	j = j1 = n / 2;
	j2 = n - 1;
	for(i = 1; i < j2; i++)
	{
		if(i < j)
		{
			w = ar[i];
			ar[i] = ar[j];
			ar[j] = w;
			w = ai[i];
			ai[i] = ai[j];
			ai[j] = w; 
		}
		k = j1;
		while(k <= j)
		{
			j -= k;
			k /= 2;
		}
		j += k;
	}
	if(flag==0)return;
	w = 1. / sqrt(n);
	for(i = 0; i < n; i++)
	{
		ar[i] *= w;
		ai[i] *= w;
	}
	return;
}

double eval_feedbacks(struct adpcm_common *adpc,double feedbacks[SBUF_SIZE]){
 double ar[SBUF_SIZE*2];
 double ai[SBUF_SIZE*2];
 double score = 0.0;
 double powr;
 double psy_rate;
 double qnoise_volume = adpc->play_volume/256.0;
 int i;

 for(i=0;i<FEEDBACKS_MAX;i++){
  ai[i] = 0.0;
  ar[i] = feedbacks[i];
 }
 for(i=FEEDBACKS_MAX;i<SBUF_SIZE*2;i++){
  ar[i] = ai[i] = 0.0;
 }

 fft1(ar,ai,SBUF_SIZE*2,0,0);
 for(i=0;i<SBUF_SIZE;i++){
  powr = sqrt(ar[i]*ar[i]+ai[i]*ai[i]+0.09)*qnoise_volume;
  psy_rate = powr*adpc->psycho_ac[i];
  score += psy_rate;//(psy_rate*psy_rate/(2.0+psy_rate*psy_rate))*sqrt(powr*adpc->ath_curve[i]);
 }
 return score/SBUF_SIZE;
}

double optimize_feedbacks(struct adpcm_common *adpc){
 double feedbacks_new[SBUF_SIZE];
 double feedbacks_deltaf[SBUF_SIZE];
 double feedbacks_distance;
 double feedbacks_center_score;
 double feedbacks_new_score;
 int i,j,k;
 int scale = 2;

 for(k=0;k<21;k++){
  feedbacks_center_score = eval_feedbacks(adpc,adpc->feedbacks);
  feedbacks_distance = 0.0;

  for(i=1;i<FEEDBACKS_MAX;i++){
   for(j=0;j<SBUF_SIZE;j++)feedbacks_new[j] = adpc->feedbacks[j];
   feedbacks_new[i] += 0.001;//delta
   feedbacks_deltaf[i] = eval_feedbacks(adpc,feedbacks_new)-feedbacks_center_score;
   feedbacks_distance += feedbacks_deltaf[i]*feedbacks_deltaf[i];
  }
  while(scale<15){
   if(scale<adpc->evalfs_hist[k])adpc->evalfs_hist[k] = scale;
   if(scale>adpc->evalfe_hist[k])adpc->evalfe_hist[k] = scale;
   double dist = (1<<scale)*0.002/sqrt(feedbacks_distance);
   for(j=1;j<FEEDBACKS_MAX;j++){
    feedbacks_new[j] = adpc->feedbacks[j] - feedbacks_deltaf[j]*dist;
   }
   feedbacks_new_score = eval_feedbacks(adpc,feedbacks_new);
   if(feedbacks_new_score<feedbacks_center_score){
    for(j=1;j<FEEDBACKS_MAX;j++){
     adpc->feedbacks[j] = feedbacks_new[j];
    }
    feedbacks_center_score = feedbacks_new_score;
    scale++;
   }
   else{
    break;
   }
  }
  if(scale<2)break;
  scale -= 3;
  if(scale<0)scale = 0;
 }

 double ar[SBUF_SIZE*2];
 double ai[SBUF_SIZE*2];
 if(adpc->sign_hist[0]<4){
  for(i=0;i<SBUF_SIZE;i++){
   ai[i] = 0;
   ar[i] = adpc->feedbacks[i];
  }
  for(i=SBUF_SIZE;i<SBUF_SIZE*2;i++){
   ar[i] = ai[i] = 0;
  }
  fft1(ar,ai,SBUF_SIZE*2,0,0);
  printf("feedback:");
  for(i=0;i<SBUF_SIZE;i++){
   printf("%d ",(int)(adpc->feedbacks[i]*1000));
  }
  printf("\r\n masking:");
  for(i=0;i<SBUF_SIZE;i++){
   printf("%d ",(int)(-log10(adpc->psycho_ac[i])*(20.0)));
  }
  printf("\r\n   noise:");
  for(i=0;i<SBUF_SIZE;i++){
   printf("%d ",(int)(log10(sqrt(ar[i]*ar[i]+ai[i]*ai[i]))*20.0));
  }
  printf("\r\n   score:");
  printf("%f ",feedbacks_center_score);

  printf("\r\n   start:");
  i = 0;
  while(adpc->evalfs_hist[i]!=99 && i<22){
   printf("%d ",adpc->evalfs_hist[i++]);
  }
  printf("\r\n     end:");
  i = 0;
  while(adpc->evalfs_hist[i]!=99 && i<22){
   printf("%d ",adpc->evalfe_hist[i++]);
  }
  printf("\r\n");

 }

 return feedbacks_center_score;
}

int adpcm(struct adpcm_common *adpc){
 double ar[BUF_SIZE];
 double ai[BUF_SIZE];
 double psycho_ac_tmp[BUF_HALF];
 int psycho_ac_shrink_shift = 0;
 while((1<<psycho_ac_shrink_shift)<RESIZE)psycho_ac_shrink_shift++;


 int i,j;
 for(i=0;i<BUF_SIZE;i++){
  double sinw = sin((i+0.5)*3.141592653589/BUF_SIZE);
  ar[i] = adpc->wav_buf[i]*sinw*sinw;
  ai[i] = 0;
 }
 fft1(ar,ai,BUF_SIZE,0,0);
 double mask_thre;
 double biased_wav,error_wav,dithered_wav;
 int dequant_wav;
 int output_wav;
 mask_thre = 0.0;
 for(i=0;i<BUF_HALF;i++){
  mask_thre += (sqrt((ar[i]*ar[i]+ai[i]*ai[i])));
  psycho_ac_tmp[i] = mask_thre;
  mask_thre *= adpc->mask_spread_for[i];
  if(i<SBUF_SIZE)adpc->psycho_ac[i] = 0.0;
 }
 mask_thre = 0.0;
 for(i=BUF_HALF-1;i>=0;i--){
  mask_thre += psycho_ac_tmp[i];
  psycho_ac_tmp[i] = mask_thre;
  mask_thre *= adpc->mask_spread_rev[i];
 }

 for(i=0;i<BUF_HALF;i++){
  adpc->psycho_ac_big[i] *= 0.9375;
  adpc->psycho_ac_big[i] += (psycho_ac_tmp[i]*adpc->mask_spread_norm[i])+adpc->ath_curve_big[i];
  adpc->psycho_ac[i>>psycho_ac_shrink_shift] += 16*RESIZE/(adpc->psycho_ac_big[i]);
 }
 adpc->psycho_ac[0] *= 2.0;

 for(i=0;i<22;i++){
  adpc->evalfs_hist[i] = 99;
  adpc->evalfe_hist[i] = 0;
 }
 //double feedbacks_score;
 double quant_step = 256.0;
 int quant_step_int = 0;

 optimize_feedbacks(adpc);

 //feedbacks_score = optimize_feedbacks(adpc);
 //while((feedbacks_score*256.0)<quant_step && quant_step_int<7){
 // quant_step *= 0.5;
 // quant_step_int++;
 //}

 for(i=0;i<ADPCM_UNIT;i++){
  biased_wav = adpc->wav_buf[i]-adpc->errors_bf[1];
  dithered_wav = biased_wav + (0.25*atan((rand()*4.0-2.0)/RAND_MAX)/256.0);
  output_wav = (int)(100000.5+(dithered_wav*quant_step));
  output_wav -= 100000;
  dequant_wav = (output_wav<<quant_step_int);
  if(dequant_wav>127)dequant_wav = 127;
  if(dequant_wav<-127)dequant_wav = -127;

  error_wav = biased_wav-(dequant_wav/256.0);
  if(error_wav<-0.1)error_wav = -0.1;
  if(error_wav>0.1)error_wav = 0.1;
  for(j=1;j<FEEDBACKS_MAX;j++){
   adpc->errors_bf[j] = adpc->errors_bf[j+1];
   adpc->errors_bf[j] += error_wav*adpc->feedbacks[j];
  }
  dequant_wav += 128;
  adpc->wav_comp[i] = (char)dequant_wav;
 }

 for(i=0;i<(BUF_SIZE-ADPCM_UNIT);i++){
  adpc->wav_buf[i] = adpc->wav_buf[i+ADPCM_UNIT];
 }
 return 0;
}


main(int argc, char **argv){
 char input_wav_path[4096] = "";
 char output_wav_path[4096] = "";
 int i,j,k;
 int input_sampling_rate;
 int input_wav_length;
 int intbuf;
 struct adpcm_common ADPC;
 struct adpcm_common *adpc;
 adpc = &ADPC;
 init_adpcm_common(adpc);
 short sbuf;
 FILE INPUT_WAV;
 FILE *input_wav;
 if(argc==1){
  printf("wav8bit.exe version 1.0.5 (http://d.hatena.ne.jp/kamedo2/)\r\n");
  printf("Monaural 16bit wav file to Monaural 8bit wav file. Very slow, high quality.\r\n\r\n");
  printf("  usage:  wav8bit input.wav [output.wav]\r\n");
  return 0;
 }
 if(1<argc){
  strcpy(input_wav_path,argv[1]);
  strcpy(output_wav_path,input_wav_path);
  int path_len = strlen(output_wav_path)-4;
  if(output_wav_path[path_len]=='.'){
   output_wav_path[path_len] = 0;
   strcat(output_wav_path,".8b.wav");
  }
 }
 if(2<argc){
  strcpy(output_wav_path,argv[2]);
 }

 printf("%s\r\n",input_wav_path);
 printf("%s\r\n",output_wav_path);


 char chunkstr[8] = {0};
 int chunk_length;
 int chunk_max = 10;
 if((input_wav = fopen(input_wav_path,"rb")) == NULL)return 1;
 fread(chunkstr,1,4,input_wav);
 if(strcmp(chunkstr,"RIFF")!=0)printf("RIFF != %s\r\n",chunkstr);
 fread(chunkstr,1,4,input_wav);
 fread(chunkstr,1,4,input_wav);
 if(strcmp(chunkstr,"WAVE")!=0)printf("WAVE != %s\r\n",chunkstr);
 fread(chunkstr,1,4,input_wav);
 while(strcmp(chunkstr,"fmt ")!=0 && (chunk_max>0)){
  printf("fmt  != %s\r\n",chunkstr);
  fread(&chunk_length,4,1,input_wav);
  for(i=0;i<chunk_length;i++)fread(chunkstr,1,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  chunk_max--;
 }

 if(chunk_max){
  fread(&chunk_length,4,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  if(chunkstr[0]!=1 || chunkstr[1]!=0){
   printf("This is not a linear PCM.\r\n");
   return 2;//linear PCM
  }
  if(chunkstr[2]!=1 || chunkstr[3]!=0){
   printf("This is not a Monaural sound(Stereo, Surround, etc.).\r\n");
   return 3;//Mono
  }
  fread(&input_sampling_rate,1,4,input_wav);
  fread(&intbuf,1,4,input_wav);
  if(intbuf!=input_sampling_rate*2){
   printf("This is not a 16bit depth wave file.\r\n");
   return 4;//8bit
  }
  for(i=0;i<chunk_length-12;i++)fread(chunkstr,1,1,input_wav);
 }

 fread(chunkstr,1,4,input_wav);
 while(strcmp(chunkstr,"data")!=0 && (chunk_max>0)){
  printf("data!=%s\r\n",chunkstr);
  fread(&chunk_length,4,1,input_wav);
  for(i=0;i<chunk_length;i++)fread(chunkstr,1,1,input_wav);
  fread(chunkstr,1,4,input_wav);
  chunk_max--;
 }
 if(chunk_max){
  fread(&input_wav_length,4,1,input_wav);
 }

 input_wav_length >>= 6;// 32 Blocks
 printf("SAMPLE RATE: %d\r\n",input_sampling_rate);
 printf(" FRAMES NUM: %d\r\n",input_wav_length);

 prepare_psycho_param(adpc,(double)input_sampling_rate);
 /*
 printf(" Hz:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.1f ",input_sampling_rate*(i+0.5)/BUF_SIZE);
 }
 printf("\r\nATH:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.1f ",adpc->ath_curve[i]);
 }
 printf("\r\nMSP:");
 for(i=0;i<BUF_HALF;i++){
  printf("%4.3f ",adpc->mask_spread[i]);
 }
 printf("\r\n");
 */

 FILE *output_wav;
 output_wav = fopen(output_wav_path,"wb");
 if(output_wav==NULL)return 4;
 fputs("RIFF",output_wav);
 intbuf = 44-8+(input_wav_length<<5);
 fwrite(&intbuf,4,1,output_wav);
 fputs("WAVE",output_wav);
 fputs("fmt ",output_wav);
 intbuf = 16;
 fwrite(&intbuf,4,1,output_wav);
 intbuf = 65536+1;
 fwrite(&intbuf,4,1,output_wav);
 fwrite(&input_sampling_rate,4,1,output_wav);
 fwrite(&input_sampling_rate,4,1,output_wav);
 intbuf = 65536*8+1;
 fwrite(&intbuf,4,1,output_wav);
 fputs("data",output_wav);
 intbuf = (input_wav_length<<5);
 fwrite(&intbuf,4,1,output_wav);

 for(j=0;j<(BUF_SIZE/ADPCM_UNIT)-1;j++){
  for(k=0;k<ADPCM_UNIT;k++){
   fread(&sbuf,2,1,input_wav);
   adpc->wav_buf[k+BUF_SIZE-ADPCM_UNIT] = ((double)sbuf)/65536.0;
  }
  adpc->sign_hist[0] = 0;
  adpcm(adpc);
 }

 for(j=0;j<input_wav_length;j++){
  if(j+(BUF_SIZE/ADPCM_UNIT)-1<input_wav_length){
   for(k=0;k<ADPCM_UNIT;k++){
    fread(&sbuf,2,1,input_wav);
    adpc->wav_buf[k+BUF_SIZE-ADPCM_UNIT] = ((double)sbuf)/65536.0;
   }
  }
  else{
   for(k=0;k<ADPCM_UNIT;k++){
    adpc->wav_buf[k+BUF_SIZE-ADPCM_UNIT] = 0.0;
   }
  }
  adpc->sign_hist[0] = 0;
  adpc->sign_hist[0] = j&0x1FFF;
  adpcm(adpc);
  fwrite(adpc->wav_comp,1,ADPCM_UNIT,output_wav);
 }
 fclose(input_wav);
 fclose(output_wav);
 return 0;
}

